#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using System.Xml;
using HeuristicLab.Data;
using HeuristicLab.Constraints;
using HeuristicLab.GP.Interfaces;

namespace HeuristicLab.GP {
  public class FunctionLibrary : ItemBase, IEditable {
    private List<IFunction> functions = new List<IFunction>();
    public IEnumerable<IFunction> Functions {
      get { return functions; }
    }

    public FunctionLibrary()
      : base() {
    }


    public void AddFunction(IFunction fun) {
      if (!functions.Contains(fun)) functions.Add(fun);
      // OnFunctionAdded(fun);
    }

    //void UpdateTreeBounds(object sender, EventArgs e) {
    //  RecalculateMinimalTreeBounds();
    //}


    //private void GetMinMaxArity(IOperator op, out int minArity, out int maxArity) {
    //  foreach (IConstraint constraint in op.Constraints) {
    //    NumberOfSubOperatorsConstraint theConstraint = constraint as NumberOfSubOperatorsConstraint;
    //    if (theConstraint != null) {
    //      minArity = theConstraint.MinOperators.Data;
    //      maxArity = theConstraint.MaxOperators.Data;
    //      return;
    //    }
    //  }
    //  // the default arity is 2
    //  minArity = 2;
    //  maxArity = 2;
    //}

    public void RemoveFunction(IFunction fun) {
      functions.Remove(fun);

      // remove the operator from the allowed sub-functions of the remaining operators
      foreach (IFunction f in Functions) {
        if (f != fun) {
        }
      }
      // OnFunctionRemoved(fun);
    }

    //public event EventHandler FunctionAdded;
    //public event EventHandler FunctionRemoved;

    //protected virtual void OnFunctionAdded(IFunction fun) {
    //  if (FunctionAdded != null) {
    //    FunctionAdded(this, new EventArgs(fun));
    //  }
    //}
    //protected virtual void OnFunctionRemoved(IFunction fun) {
    //  if (FunctionRemoved != null) {
    //    FunctionRemoved(this, new EventArgs(fun));
    //  }
    //}

    public override IView CreateView() {
      return new FunctionLibraryEditor(this);
    }

    #region IEditable Members

    public IEditor CreateEditor() {
      return new FunctionLibraryEditor(this);
    }

    #endregion
  }
}
